// Copyright (c) 2009 INRIA Sophia-Antipolis (France).
// All rights reserved.
//
// This file is part of CGAL (www.cgal.org); you may redistribute it under
// the terms of the Q Public License version 1.0.
// See the file LICENSE.QPL distributed with CGAL.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// $URL: svn+ssh://scm.gforge.inria.fr/svn/cgal/trunk/Mesh_3/test/Mesh_3/test_utilities.h $
// $Id: test_utilities.h 50092 2009-06-26 08:58:47Z stayeb $
//
//
// Author(s)     : Stephane Tayeb
//
//******************************************************************************
// File Description :
//
//******************************************************************************

#ifndef TEST_UTILITIES_H_
#define TEST_UTILITIES_H_


#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/Exact_predicates_exact_constructions_kernel.h>

#include <CGAL/Mesh_triangulation_3.h>
#include <CGAL/Mesh_complex_3_in_triangulation_3.h>

struct K_e_i : public CGAL::Exact_predicates_inexact_constructions_kernel {};
struct K_e_e : public CGAL::Exact_predicates_exact_constructions_kernel {};

namespace CGAL {
namespace details {

template<>
struct Mesh_geom_traits_generator<K_e_e>
{
private:
  typedef Regular_triangulation_euclidean_traits_3<K_e_e> Geom_traits;

public:
  typedef Geom_traits type;
  typedef type Type;
};  // end struct Mesh_geom_traits_generator<...>

} // end namespace details
} // end namespace CGAL


#endif // TEST_UTILITIES_H_
