// ============================================================================
//
// Copyright (c) 1997-2002 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: $
// release_date  : $CGAL_Date: $
//
// file          : test/Nef_3/nef_3.h
// package       : Nef_3
// chapter       : 3D-Nef Polyhedra
//
// revision      : $Id: test_with_extended_homogeneous.cpp 45745 2008-09-25 06:11:35Z afabri $
// revision_date : $Date: 2008-09-25 08:11:35 +0200 (Thu, 25 Sep 2008) $
//
// author(s)     : Peter Hachenberger <hachenberger@mpi-sb.mpg.de>
// maintainer    : Peter Hachenberger <hachenberger@mpi-sb.mpg.de>
// coordinator   : MPI Saarbruecken
//
// ============================================================================

#define CGAL_NEF3_SORT_OUTPUT 1

#include <CGAL/basic.h>
#ifdef CGAL_USE_LEDA
#include <CGAL/leda_integer.h>
typedef leda_integer NT;
#else
#include <CGAL/Gmpz.h>
typedef CGAL::Gmpz NT;
#endif
#include <CGAL/Extended_homogeneous.h>
#include <CGAL/Timer.h>
#include <CGAL/test_Nef_3.h>

int main() {
  typedef CGAL::Extended_homogeneous<NT> EH_kernel;
  
#ifdef CGAL_CFG_ISTREAM_INT_BUG
  std::locale::global(std::locale("C")); 
#endif

  CGAL::test_Nef_3<EH_kernel>  test_EH;

  CGAL::Timer t;
  t.start();
  test_EH.run_test();
  t.stop();
  std::cout << "Extended homogeneous kernel successful in: " 
	    << t.time() << " seconds " << std::endl;
}

