// ============================================================================
//
// Copyright (c) 2001-2006 Max-Planck-Institut Saarbruecken (Germany).
// All rights reserved.
//
// This file is part of EXACUS (http://www.mpi-inf.mpg.de/projects/EXACUS/);
// you may redistribute it under the terms of the Q Public License version 1.0.
// See the file LICENSE.QPL distributed with EXACUS.
//
// Licensees holding a valid commercial license may use this file in
// accordance with the commercial license agreement provided with the software.
//
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
// ----------------------------------------------------------------------------
//
// Library       : CGAL 
// File          : test/modular_gcd_utcf_algorithm_M.C
// CGAL_release   : $Name:  $
// Revision      : $Revision: 51456 $
// Revision_date : $Date: 2009-08-24 19:10:04 +0200 (Mon, 24 Aug 2009) $ 
//
// Author(s)     : Dominik Hlse <dominik.huelse@gmx.de>
//                 Michael Hemmer <hemmer@mpi-inf.mpg.de>
//
// ============================================================================
/*! \file CGAL/polynomial_gcd.C
    test for the modular algorithm modular_gcd_utcf_algorithm_M to compute the gcd of 
    univariate polynomials with integer coefficients
*/ 

#define MY_FUNCTION_CALL modular_gcd_utcf_algorithm_M
 
#include <CGAL/basic.h>
#include <CGAL/Arithmetic_kernel.h> 
#include <CGAL/gen_polynomials.h>
#include <CGAL/test_modular_gcd.h>

int main(){
    
  // Set wrong rounding mode to test modular arithmetic 
  CGAL::Protect_FPU_rounding<true> pfr(CGAL_FE_UPWARD);
  #ifdef CGAL_USE_LEDA
   CGAL::internal::test_modular_gcd<CGAL::LEDA_arithmetic_kernel>
       (CGAL::Unique_factorization_domain_tag());
  #endif // CGAL_USE_LEDA    

  #ifdef CGAL_USE_CORE    
   CGAL::internal::test_modular_gcd<CGAL::CORE_arithmetic_kernel>
       (CGAL::Unique_factorization_domain_tag());
  #endif // Lis_HAVE_CORE
     
  return 0;
}


// EOF
